<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>The ESP-AT MQTT library project: src/AT.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">The ESP-AT MQTT library project
   </div>
   <div id="projectbrief">A simple wrapper to the MQTT functionality found in the ESP-AT interpreter</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">AT.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="AT_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * ----------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *                        _ _           _</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *                       (_) |         | |</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *                        _| |     __ _| |__  ___</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *                       | | |    / _` | &#39;_ \/ __|</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *                       | | |___| (_| | |_) \__ \</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *                       |_|______\__,_|_.__/|___/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * ----------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">  Copyright (c) 2022 iLabs - Pontus Oldberg</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"></span> </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">  Permission is hereby granted, free of charge, to any person obtaining a copy</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">  of this software and associated documentation files (the &quot;Software&quot;), to deal</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">  in the Software without restriction, including without limitation the rights</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">  copies of the Software, and to permit persons to whom the Software is</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">  furnished to do so, subject to the following conditions:</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"></span> </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">  The above copyright notice and this permission notice shall be included in all</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">  copies or substantial portions of the Software.</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"></span> </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment">  THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment">  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment">  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment">  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment">  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment">  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment">  SOFTWARE.</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * ----------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &lt;inttypes.h&gt;</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;Arduino.h&gt;</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#ifndef _H_AT_COM_</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#define _H_AT_COM_</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701">   47</a></span>&#160;<span class="keyword">enum</span> <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701">status_code_e</a> {</div>
<div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ab65c93b365084d675c9c8d2cb85c5aee">   48</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ab65c93b365084d675c9c8d2cb85c5aee">ESP_AT_SUB_OK</a>                   = 0x00000000, </div>
<div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad878aae06ef0af5bf7459d4e732d28e3">   49</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad878aae06ef0af5bf7459d4e732d28e3">ESP_AT_SUB_COMMON_ERROR</a>         = 0x01010000, </div>
<div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a8ece757353d9b9d754fe7ee3dffdf009">   50</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a8ece757353d9b9d754fe7ee3dffdf009">ESP_AT_SUB_NO_TERMINATOR</a>        = 0x01020000, </div>
<div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701aac490b7434e97cd6dda5dc06829a4752">   51</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701aac490b7434e97cd6dda5dc06829a4752">ESP_AT_SUB_NO_AT</a>                = 0x01030000, </div>
<div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad6e0b28873f7e82345fb0892c275d623">   52</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad6e0b28873f7e82345fb0892c275d623">ESP_AT_SUB_PARA_LENGTH_MISMATCH</a> = 0x01040000, </div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a9f262dfc988438706a55a29a1748ae43">   53</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a9f262dfc988438706a55a29a1748ae43">ESP_AT_SUB_PARA_TYPE_MISMATCH</a>   = 0x01050000, </div>
<div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ac6b5b10f52ea2612d8628f1897142997">   54</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ac6b5b10f52ea2612d8628f1897142997">ESP_AT_SUB_PARA_NUM_MISMATCH</a>    = 0x01060000, </div>
<div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a2172796f23c221f4cee294a77fff49ed">   55</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a2172796f23c221f4cee294a77fff49ed">ESP_AT_SUB_PARA_INVALID</a>         = 0x01070000, </div>
<div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad9f84cae5eb8ee91f43e7a94becf5477">   56</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad9f84cae5eb8ee91f43e7a94becf5477">ESP_AT_SUB_PARA_PARSE_FAIL</a>      = 0x01080000, </div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ab3cd1c1b8a2a49a2111c57a512ef64c1">   57</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ab3cd1c1b8a2a49a2111c57a512ef64c1">ESP_AT_SUB_UNSUPPORT_CMD</a>        = 0x01090000, </div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701aa30973841455529fae37712f3aa654a0">   58</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701aa30973841455529fae37712f3aa654a0">ESP_AT_SUB_CMD_EXEC_FAIL</a>        = 0x010a0000, </div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a829f94a8131058d90776ede8fa667dd2">   59</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a829f94a8131058d90776ede8fa667dd2">ESP_AT_SUB_CMD_PROCESSING</a>       = 0x010b0000, </div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a7ce30c99b5146f6e284e805b9beb4a6f">   61</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a7ce30c99b5146f6e284e805b9beb4a6f">ESP_AT_SUB_CMD_OP_ERROR</a>         = 0x010c0000, </div>
<div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a237643f44341c133761b13963b206fd2">   62</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a237643f44341c133761b13963b206fd2">ESP_AT_SUB_CMD_ERROR</a>            = 0x010d0000, </div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a655b31e3aea3a2dd38449cc2f2290afd">   63</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a655b31e3aea3a2dd38449cc2f2290afd">ESP_AT_SUB_CMD_TIMEOUT</a>          = 0x010e0000, </div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a5256452d9f75d0e7cea6ee0165dde42c">   64</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a5256452d9f75d0e7cea6ee0165dde42c">ESP_AT_SUB_CMD_CONN_SYNCH</a>       = 0x010f0000, </div>
<div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a3a4aba89e732f3573f346bb05fee636b">   65</a></span>&#160;  <a class="code" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a3a4aba89e732f3573f346bb05fee636b">ESP_AT_SUB_CMD_CONN_ASYNCH</a>      = 0x01100000, </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;  ESP_AT_SUB_CMD_LAST_COMMAND</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;};</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="preprocessor">#define AT_ERROR(x)       (x &amp; 0x00ff0000)</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">   77</a></span>&#160;<span class="keyword">typedef</span> uint32_t          <a class="code" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a>;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div>
<div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="classAT__Class.html">   90</a></span>&#160;<span class="keyword">class </span><a class="code" href="classAT__Class.html">AT_Class</a> {</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;  <a class="code" href="classAT__Class.html#adc0b586b4dc8843104625b18382cfd32">AT_Class</a>(HardwareSerial* = &amp;ESP_SERIAL_PORT);</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;  <span class="keywordtype">size_t</span> <a class="code" href="classAT__Class.html#a389087939b169b92aad704b89cfcaa69">readLine</a>();</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;  <a class="code" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> <a class="code" href="classAT__Class.html#a408c1ed423d049988df1f0badbb89ebb">waitReply</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *asynch, uint32_t timeout);</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;  <a class="code" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> <a class="code" href="classAT__Class.html#a865aafe93ba8a75f82d084ea3885dc51">sendCommand</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *cmd, <span class="keyword">const</span> <span class="keywordtype">char</span> *param, <span class="keywordtype">char</span> **result,</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;                            <span class="keyword">const</span> <span class="keywordtype">char</span> *asynch = NULL, uint32_t timeout=2000);</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;  <a class="code" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> <a class="code" href="classAT__Class.html#a54f448639cbcd8bbcae4a18d0c6ba740">waitPrompt</a>(uint32_t timeout);</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;  <a class="code" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> <a class="code" href="classAT__Class.html#a6f727c41336bcfe3f6e6648a23e707c3">waitString</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *str, uint32_t timeout);</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;  <a class="code" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> <a class="code" href="classAT__Class.html#a41bef8b8a58592d0c71901926cb1666a">sendString</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *str, <span class="keywordtype">size_t</span> len);</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;  <a class="code" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> <a class="code" href="classAT__Class.html#a41bef8b8a58592d0c71901926cb1666a">sendString</a>(<span class="keywordtype">char</span> *str, <span class="keywordtype">size_t</span> len);</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;  <a class="code" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> <a class="code" href="classAT__Class.html#a41bef8b8a58592d0c71901926cb1666a">sendString</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *str);</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;  <span class="keywordtype">char</span> <a class="code" href="classAT__Class.html#ab5e6819d3dc047498198c681eb02d90d">read</a>();</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;  <span class="keywordtype">int</span> <a class="code" href="classAT__Class.html#acf3c1e982cd25c20cf11e2920e101b31">available</a>();</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;  <span class="keywordtype">char</span> *<a class="code" href="classAT__Class.html#aae45145ffe1c153d10b3feeba141f496">getBuff</a>();</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;  HardwareSerial* _serial;</div>
<div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="classAT__Class.html#ac5aeb70c1e9254c9928328d239a58825">  109</a></span>&#160;  <span class="keywordtype">char</span> <a class="code" href="classAT__Class.html#ac5aeb70c1e9254c9928328d239a58825">buff</a>[1024];    </div>
<div class="line"><a name="l00110"></a><span class="lineno"><a class="line" href="classAT__Class.html#a55115f87056e336f9aa640b986b651c2">  110</a></span>&#160;  <span class="keywordtype">char</span> <a class="code" href="classAT__Class.html#a55115f87056e336f9aa640b986b651c2">cmdBuff</a>[256];  </div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="classAT__Class.html#a0c1ad8f178ca5018ce94a7b4bdb1a02b">  111</a></span>&#160;  <span class="keywordtype">char</span> <a class="code" href="classAT__Class.html#a0c1ad8f178ca5018ce94a7b4bdb1a02b">resBuff</a>[128];  </div>
<div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="classAT__Class.html#a4fb40d576da2508322ada4cd9d525c87">  112</a></span>&#160;  <span class="keywordtype">int</span> <a class="code" href="classAT__Class.html#a4fb40d576da2508322ada4cd9d525c87">wx</a>;             </div>
<div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="classAT__Class.html#af02fefaf594962a878cffffc78b703e4">  113</a></span>&#160;  <span class="keywordtype">int</span> <a class="code" href="classAT__Class.html#af02fefaf594962a878cffffc78b703e4">line</a>;           </div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;};</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="preprocessor">#endif</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701a5256452d9f75d0e7cea6ee0165dde42c"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a5256452d9f75d0e7cea6ee0165dde42c">ESP_AT_SUB_CMD_CONN_SYNCH</a></div><div class="ttdeci">@ ESP_AT_SUB_CMD_CONN_SYNCH</div><div class="ttdoc">MQTT connection was synchronous.</div><div class="ttdef"><b>Definition:</b> AT.h:64</div></div>
<div class="ttc" id="aclassAT__Class_html_adc0b586b4dc8843104625b18382cfd32"><div class="ttname"><a href="classAT__Class.html#adc0b586b4dc8843104625b18382cfd32">AT_Class::AT_Class</a></div><div class="ttdeci">AT_Class(HardwareSerial *=&amp;ESP_SERIAL_PORT)</div><div class="ttdoc">The class constructor is used to set the serial port to be used to communicate with the ESP-AT device...</div><div class="ttdef"><b>Definition:</b> AT.cpp:51</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701a8ece757353d9b9d754fe7ee3dffdf009"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a8ece757353d9b9d754fe7ee3dffdf009">ESP_AT_SUB_NO_TERMINATOR</a></div><div class="ttdeci">@ ESP_AT_SUB_NO_TERMINATOR</div><div class="ttdoc">The At interpretor did not detect a terminator.</div><div class="ttdef"><b>Definition:</b> AT.h:50</div></div>
<div class="ttc" id="aclassAT__Class_html_a865aafe93ba8a75f82d084ea3885dc51"><div class="ttname"><a href="classAT__Class.html#a865aafe93ba8a75f82d084ea3885dc51">AT_Class::sendCommand</a></div><div class="ttdeci">at_status_t sendCommand(const char *cmd, const char *param, char **result, const char *asynch=NULL, uint32_t timeout=2000)</div><div class="ttdoc">This function sends the specified AT command and parameters to the ESP-AT device on the serial line.</div><div class="ttdef"><b>Definition:</b> AT.cpp:210</div></div>
<div class="ttc" id="aclassAT__Class_html_a4fb40d576da2508322ada4cd9d525c87"><div class="ttname"><a href="classAT__Class.html#a4fb40d576da2508322ada4cd9d525c87">AT_Class::wx</a></div><div class="ttdeci">int wx</div><div class="ttdoc">Write pointer to the input buffer while processing an ESP-AT response.</div><div class="ttdef"><b>Definition:</b> AT.h:112</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701ad9f84cae5eb8ee91f43e7a94becf5477"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad9f84cae5eb8ee91f43e7a94becf5477">ESP_AT_SUB_PARA_PARSE_FAIL</a></div><div class="ttdeci">@ ESP_AT_SUB_PARA_PARSE_FAIL</div><div class="ttdoc">Failed to parse parameter.</div><div class="ttdef"><b>Definition:</b> AT.h:56</div></div>
<div class="ttc" id="aclassAT__Class_html_acf3c1e982cd25c20cf11e2920e101b31"><div class="ttname"><a href="classAT__Class.html#acf3c1e982cd25c20cf11e2920e101b31">AT_Class::available</a></div><div class="ttdeci">int available()</div><div class="ttdoc">Checks to see if there are any data available on the serial port.</div><div class="ttdef"><b>Definition:</b> AT.cpp:402</div></div>
<div class="ttc" id="aclassAT__Class_html_ac5aeb70c1e9254c9928328d239a58825"><div class="ttname"><a href="classAT__Class.html#ac5aeb70c1e9254c9928328d239a58825">AT_Class::buff</a></div><div class="ttdeci">char buff[1024]</div><div class="ttdoc">Serial input buffer.</div><div class="ttdef"><b>Definition:</b> AT.h:109</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701ac6b5b10f52ea2612d8628f1897142997"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ac6b5b10f52ea2612d8628f1897142997">ESP_AT_SUB_PARA_NUM_MISMATCH</a></div><div class="ttdeci">@ ESP_AT_SUB_PARA_NUM_MISMATCH</div><div class="ttdoc">Incorrect number of parameters.</div><div class="ttdef"><b>Definition:</b> AT.h:54</div></div>
<div class="ttc" id="aAT_8h_html_a0c488f966048be07ee0f11f6969c3524"><div class="ttname"><a href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a></div><div class="ttdeci">uint32_t at_status_t</div><div class="ttdoc">The return value of an AT operation.</div><div class="ttdef"><b>Definition:</b> AT.h:77</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701aac490b7434e97cd6dda5dc06829a4752"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701aac490b7434e97cd6dda5dc06829a4752">ESP_AT_SUB_NO_AT</a></div><div class="ttdeci">@ ESP_AT_SUB_NO_AT</div><div class="ttdoc">Command was not prepended with &quot;AT&quot;.</div><div class="ttdef"><b>Definition:</b> AT.h:51</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701a9f262dfc988438706a55a29a1748ae43"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a9f262dfc988438706a55a29a1748ae43">ESP_AT_SUB_PARA_TYPE_MISMATCH</a></div><div class="ttdeci">@ ESP_AT_SUB_PARA_TYPE_MISMATCH</div><div class="ttdoc">Wrong parameter type.</div><div class="ttdef"><b>Definition:</b> AT.h:53</div></div>
<div class="ttc" id="aclassAT__Class_html_af02fefaf594962a878cffffc78b703e4"><div class="ttname"><a href="classAT__Class.html#af02fefaf594962a878cffffc78b703e4">AT_Class::line</a></div><div class="ttdeci">int line</div><div class="ttdoc">Keeps track of how many lines have been received during the processing of an ESP-AT reply.</div><div class="ttdef"><b>Definition:</b> AT.h:113</div></div>
<div class="ttc" id="aclassAT__Class_html_a6f727c41336bcfe3f6e6648a23e707c3"><div class="ttname"><a href="classAT__Class.html#a6f727c41336bcfe3f6e6648a23e707c3">AT_Class::waitString</a></div><div class="ttdeci">at_status_t waitString(const char *str, uint32_t timeout)</div><div class="ttdoc">Wait for a specific string to arrive on the serial port.</div><div class="ttdef"><b>Definition:</b> AT.cpp:285</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701ad878aae06ef0af5bf7459d4e732d28e3"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad878aae06ef0af5bf7459d4e732d28e3">ESP_AT_SUB_COMMON_ERROR</a></div><div class="ttdeci">@ ESP_AT_SUB_COMMON_ERROR</div><div class="ttdoc">A generic error has occured, no more info is available.</div><div class="ttdef"><b>Definition:</b> AT.h:49</div></div>
<div class="ttc" id="aclassAT__Class_html_a408c1ed423d049988df1f0badbb89ebb"><div class="ttname"><a href="classAT__Class.html#a408c1ed423d049988df1f0badbb89ebb">AT_Class::waitReply</a></div><div class="ttdeci">at_status_t waitReply(const char *asynch, uint32_t timeout)</div><div class="ttdoc">Read all lines until the end of the AT command sequence All lines are stored in buff[] separated with...</div><div class="ttdef"><b>Definition:</b> AT.cpp:112</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701">status_code_e</a></div><div class="ttdeci">status_code_e</div><div class="ttdoc">Status codes that the AT handler can return.</div><div class="ttdef"><b>Definition:</b> AT.h:47</div></div>
<div class="ttc" id="aclassAT__Class_html_a389087939b169b92aad704b89cfcaa69"><div class="ttname"><a href="classAT__Class.html#a389087939b169b92aad704b89cfcaa69">AT_Class::readLine</a></div><div class="ttdeci">size_t readLine()</div><div class="ttdoc">Read exactly one line from the serial port.</div><div class="ttdef"><b>Definition:</b> AT.cpp:66</div></div>
<div class="ttc" id="aclassAT__Class_html_a55115f87056e336f9aa640b986b651c2"><div class="ttname"><a href="classAT__Class.html#a55115f87056e336f9aa640b986b651c2">AT_Class::cmdBuff</a></div><div class="ttdeci">char cmdBuff[256]</div><div class="ttdoc">Command buffer for stuff sent to the ESP-AT device.</div><div class="ttdef"><b>Definition:</b> AT.h:110</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701a829f94a8131058d90776ede8fa667dd2"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a829f94a8131058d90776ede8fa667dd2">ESP_AT_SUB_CMD_PROCESSING</a></div><div class="ttdeci">@ ESP_AT_SUB_CMD_PROCESSING</div><div class="ttdoc">Error in command processing, this error always occur before a MQTT error happens.</div><div class="ttdef"><b>Definition:</b> AT.h:59</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701a237643f44341c133761b13963b206fd2"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a237643f44341c133761b13963b206fd2">ESP_AT_SUB_CMD_ERROR</a></div><div class="ttdeci">@ ESP_AT_SUB_CMD_ERROR</div><div class="ttdoc">Generic command error.</div><div class="ttdef"><b>Definition:</b> AT.h:62</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701a2172796f23c221f4cee294a77fff49ed"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a2172796f23c221f4cee294a77fff49ed">ESP_AT_SUB_PARA_INVALID</a></div><div class="ttdeci">@ ESP_AT_SUB_PARA_INVALID</div><div class="ttdoc">Invalid parameter value.</div><div class="ttdef"><b>Definition:</b> AT.h:55</div></div>
<div class="ttc" id="aclassAT__Class_html"><div class="ttname"><a href="classAT__Class.html">AT_Class</a></div><div class="ttdoc">EspAT MQTT AT_Class definition.</div><div class="ttdef"><b>Definition:</b> AT.h:90</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701ab3cd1c1b8a2a49a2111c57a512ef64c1"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ab3cd1c1b8a2a49a2111c57a512ef64c1">ESP_AT_SUB_UNSUPPORT_CMD</a></div><div class="ttdeci">@ ESP_AT_SUB_UNSUPPORT_CMD</div><div class="ttdoc">Found unsupported command.</div><div class="ttdef"><b>Definition:</b> AT.h:57</div></div>
<div class="ttc" id="aclassAT__Class_html_a0c1ad8f178ca5018ce94a7b4bdb1a02b"><div class="ttname"><a href="classAT__Class.html#a0c1ad8f178ca5018ce94a7b4bdb1a02b">AT_Class::resBuff</a></div><div class="ttdeci">char resBuff[128]</div><div class="ttdoc">Result buffer for parameter data returned from the ESP-AT device.</div><div class="ttdef"><b>Definition:</b> AT.h:111</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701aa30973841455529fae37712f3aa654a0"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701aa30973841455529fae37712f3aa654a0">ESP_AT_SUB_CMD_EXEC_FAIL</a></div><div class="ttdeci">@ ESP_AT_SUB_CMD_EXEC_FAIL</div><div class="ttdoc">Command execution failed.</div><div class="ttdef"><b>Definition:</b> AT.h:58</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701a655b31e3aea3a2dd38449cc2f2290afd"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a655b31e3aea3a2dd38449cc2f2290afd">ESP_AT_SUB_CMD_TIMEOUT</a></div><div class="ttdeci">@ ESP_AT_SUB_CMD_TIMEOUT</div><div class="ttdoc">AT_Class timout waiting for a reply from the interpreter.</div><div class="ttdef"><b>Definition:</b> AT.h:63</div></div>
<div class="ttc" id="aclassAT__Class_html_a41bef8b8a58592d0c71901926cb1666a"><div class="ttname"><a href="classAT__Class.html#a41bef8b8a58592d0c71901926cb1666a">AT_Class::sendString</a></div><div class="ttdeci">at_status_t sendString(const char *str, size_t len)</div><div class="ttdoc">Send a generic string on the serial port.</div><div class="ttdef"><b>Definition:</b> AT.cpp:323</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701a3a4aba89e732f3573f346bb05fee636b"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a3a4aba89e732f3573f346bb05fee636b">ESP_AT_SUB_CMD_CONN_ASYNCH</a></div><div class="ttdeci">@ ESP_AT_SUB_CMD_CONN_ASYNCH</div><div class="ttdoc">MQTT connection was asynchronous, a callback will be issued when the connection is made.</div><div class="ttdef"><b>Definition:</b> AT.h:65</div></div>
<div class="ttc" id="aclassAT__Class_html_ab5e6819d3dc047498198c681eb02d90d"><div class="ttname"><a href="classAT__Class.html#ab5e6819d3dc047498198c681eb02d90d">AT_Class::read</a></div><div class="ttdeci">char read()</div><div class="ttdoc">Reads a byte from the serial port.</div><div class="ttdef"><b>Definition:</b> AT.cpp:385</div></div>
<div class="ttc" id="aclassAT__Class_html_aae45145ffe1c153d10b3feeba141f496"><div class="ttname"><a href="classAT__Class.html#aae45145ffe1c153d10b3feeba141f496">AT_Class::getBuff</a></div><div class="ttdeci">char * getBuff()</div><div class="ttdoc">Returns a pointer to the internal receive buffer.</div><div class="ttdef"><b>Definition:</b> AT.cpp:373</div></div>
<div class="ttc" id="aclassAT__Class_html_a54f448639cbcd8bbcae4a18d0c6ba740"><div class="ttname"><a href="classAT__Class.html#a54f448639cbcd8bbcae4a18d0c6ba740">AT_Class::waitPrompt</a></div><div class="ttdeci">at_status_t waitPrompt(uint32_t timeout)</div><div class="ttdoc">Waits for a prompt of the character '&gt;' to arrive on the serial port.</div><div class="ttdef"><b>Definition:</b> AT.cpp:257</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701ad6e0b28873f7e82345fb0892c275d623"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad6e0b28873f7e82345fb0892c275d623">ESP_AT_SUB_PARA_LENGTH_MISMATCH</a></div><div class="ttdeci">@ ESP_AT_SUB_PARA_LENGTH_MISMATCH</div><div class="ttdoc">Mismatch in the parameter length.</div><div class="ttdef"><b>Definition:</b> AT.h:52</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701ab65c93b365084d675c9c8d2cb85c5aee"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ab65c93b365084d675c9c8d2cb85c5aee">ESP_AT_SUB_OK</a></div><div class="ttdeci">@ ESP_AT_SUB_OK</div><div class="ttdoc">All is good in life and no errors have been detected.</div><div class="ttdef"><b>Definition:</b> AT.h:48</div></div>
<div class="ttc" id="aAT_8h_html_a796b7f69ede31ae39a12a24208c20701a7ce30c99b5146f6e284e805b9beb4a6f"><div class="ttname"><a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a7ce30c99b5146f6e284e805b9beb4a6f">ESP_AT_SUB_CMD_OP_ERROR</a></div><div class="ttdeci">@ ESP_AT_SUB_CMD_OP_ERROR</div><div class="ttdoc">Error while performing and operation.</div><div class="ttdef"><b>Definition:</b> AT.h:61</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
